diff -Naur -x .svn stamp-0.9.10/intruder/decoder.c stamp-0.9.10_Distribute/intruder/decoder.c
--- stamp-0.9.10/intruder/decoder.c	2008-09-09 07:41:52.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/decoder.c	2014-12-18 12:19:24.970661388 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 #include <assert.h>
 #include <stdlib.h>
@@ -79,6 +80,9 @@
 #include "queue.h"
 #include "tm.h"
 #include "types.h"
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+#include "rbtree.h"
+#endif
 
 
 struct decoder {
@@ -103,7 +107,10 @@
 
     decoderPtr = (decoder_t*)malloc(sizeof(decoder_t));
     if (decoderPtr) {
-        decoderPtr->fragmentedMapPtr = MAP_ALLOC(NULL, NULL);
+	/* Modified by Odaira begin */
+        decoderPtr->fragmentedMapPtr = TMMAP_ALLOC(NULL, NULL);
+        /*decoderPtr->fragmentedMapPtr = MAP_ALLOC(NULL, NULL);*/
+	/* Modified by Odaira end */
         assert(decoderPtr->fragmentedMapPtr);
         decoderPtr->decodedQueuePtr = queue_alloc(1024);
         assert(decoderPtr->decodedQueuePtr);
@@ -121,7 +128,10 @@
 decoder_free (decoder_t* decoderPtr)
 {
     queue_free(decoderPtr->decodedQueuePtr);
-    MAP_FREE(decoderPtr->fragmentedMapPtr);
+    /* Modified by Odaira begin */
+    TMMAP_FREE(decoderPtr->fragmentedMapPtr);
+    /*MAP_FREE(decoderPtr->fragmentedMapPtr);*/
+    /* Modified by Odaira end */
     free(decoderPtr);
 }
 
@@ -341,14 +351,25 @@
     if (numFragment > 1) {
 
         MAP_T* fragmentedMapPtr = decoderPtr->fragmentedMapPtr;
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+	rbtree_t *fragmentListPtr =
+	    (rbtree_t*)TMMAP_FIND(fragmentedMapPtr, (void*)flowId);
+#else
         list_t* fragmentListPtr =
             (list_t*)TMMAP_FIND(fragmentedMapPtr, (void*)flowId);
+#endif
 
         if (fragmentListPtr == NULL) {
 
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+	    fragmentListPtr = TMRBTREE_ALLOC(&packet_compareFragmentId);
+	    assert(fragmentListPtr);
+	    status = TMRBTREE_INSERT(fragmentListPtr, (void*)packetPtr, (void*)packetPtr);
+#else
             fragmentListPtr = TMLIST_ALLOC(&packet_compareFragmentId);
             assert(fragmentListPtr);
             status = TMLIST_INSERT(fragmentListPtr, (void*)packetPtr);
+#endif
             assert(status);
             status = TMMAP_INSERT(fragmentedMapPtr,
                                   (void*)flowId,
@@ -357,11 +378,16 @@
 
         } else {
 
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+	    packet_t* firstFragmentPtr =
+		(packet_t*)TMRBTREE_GET_ROOT_KEY(fragmentListPtr);
+#else
             list_iter_t it;
             TMLIST_ITER_RESET(&it, fragmentListPtr);
             assert(TMLIST_ITER_HASNEXT(&it, fragmentListPtr));
             packet_t* firstFragmentPtr =
                 (packet_t*)TMLIST_ITER_NEXT(&it, fragmentListPtr);
+#endif
             long expectedNumFragment = firstFragmentPtr->numFragment;
 
             if (numFragment != expectedNumFragment) {
@@ -370,21 +396,47 @@
                 return ERROR_NUMFRAGMENT;
             }
 
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+	    status = TMRBTREE_INSERT(fragmentListPtr, (void*)packetPtr, (void*)packetPtr);
+#else
             status = TMLIST_INSERT(fragmentListPtr, (void*)packetPtr);
+#endif
             assert(status);
 
             /*
              * If we have all the fragments we can reassemble them
              */
 
-            if (TMLIST_GETSIZE(fragmentListPtr) == numFragment) {
+            if (
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+		TMRBTREE_GET_SIZE(fragmentListPtr) == numFragment
+#else
+		TMLIST_GETSIZE(fragmentListPtr) == numFragment
+#endif
+		) {
 
                 long numByte = 0;
                 long i = 0;
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+		rbtree_iter_t it;
+		TMRBTREE_ITER_RESET(&it, fragmentListPtr);
+#else
                 TMLIST_ITER_RESET(&it, fragmentListPtr);
-                while (TMLIST_ITER_HASNEXT(&it, fragmentListPtr)) {
+#endif
+                while (
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+		       TMRBTREE_ITER_HASNEXT(&it, fragmentListPtr)
+#else
+		       TMLIST_ITER_HASNEXT(&it, fragmentListPtr)
+#endif
+		       ) {
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+                    packet_t* fragmentPtr =
+                        (packet_t*)TMRBTREE_ITER_NEXT(&it, fragmentListPtr);
+#else
                     packet_t* fragmentPtr =
                         (packet_t*)TMLIST_ITER_NEXT(&it, fragmentListPtr);
+#endif
                     assert(fragmentPtr->flowId == flowId);
                     if (fragmentPtr->fragmentId != i) {
                         status = TMMAP_REMOVE(fragmentedMapPtr, (void*)flowId);
@@ -399,10 +451,25 @@
                 assert(data);
                 data[numByte] = '\0';
                 char* dst = data;
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+                TMRBTREE_ITER_RESET(&it, fragmentListPtr);
+#else
                 TMLIST_ITER_RESET(&it, fragmentListPtr);
-                while (TMLIST_ITER_HASNEXT(&it, fragmentListPtr)) {
+#endif
+                while (
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+		       TMRBTREE_ITER_HASNEXT(&it, fragmentListPtr)
+#else
+		       TMLIST_ITER_HASNEXT(&it, fragmentListPtr)
+#endif
+		       ) {
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+                    packet_t* fragmentPtr =
+                        (packet_t*)TMRBTREE_ITER_NEXT(&it, fragmentListPtr);
+#else
                     packet_t* fragmentPtr =
                         (packet_t*)TMLIST_ITER_NEXT(&it, fragmentListPtr);
+#endif
                     memcpy(dst, fragmentPtr->data, fragmentPtr->length);
                     dst += fragmentPtr->length;
                 }
@@ -417,7 +484,11 @@
                 status = TMQUEUE_PUSH(decodedQueuePtr, (void*)decodedPtr);
                 assert(status);
 
+#ifdef USE_RBTREE_FOR_FRAGMENT_REASSEMBLE
+                TMRBTREE_FREE(fragmentListPtr);
+#else
                 TMLIST_FREE(fragmentListPtr);
+#endif
                 status = TMMAP_REMOVE(fragmentedMapPtr, (void*)flowId);
                 assert(status);
             }
diff -Naur -x .svn stamp-0.9.10/intruder/Defines.common.mk stamp-0.9.10_Distribute/intruder/Defines.common.mk
--- stamp-0.9.10/intruder/Defines.common.mk	2008-09-09 07:41:52.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/Defines.common.mk	2014-12-18 15:40:06.573611047 +0900
@@ -3,8 +3,11 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+hostname := $(shell hostname)
+
 PROG := intruder
 
 SRCS += \
@@ -21,13 +24,65 @@
 	$(LIB)/queue.c \
 	$(LIB)/random.c \
 	$(LIB)/rbtree.c \
+	$(LIB)/hashtable.c \
+	$(LIB)/conc_hashtable.c \
 	$(LIB)/thread.c \
 	$(LIB)/vector.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+CFLAGS += -DUSE_TLH
+
+ifeq ($(enable_IBM_optimizations),yes)
+CFLAGS += -DMAP_USE_CONCUREENT_HASHTABLE -DHASHTABLE_SIZE_FIELD -DHASHTABLE_RESIZABLE
+CFLAGS += -DUSE_RBTREE_FOR_FRAGMENT_REASSEMBLE -DRBTREE_SIZE_FIELD
+else
 CFLAGS += -DMAP_USE_RBTREE
+endif
+
+RUNPARAMS := -a10 -l128 -n262144 -s1
+
+.PHONY:	run1 run2 run4 run6 run8 run12 run16 run32 run64 run128 run-16 run-32 run-64
+
+run1:
+	$(PROGRAM) $(RUNPARAMS) -t1
+
+run2:
+	$(PROGRAM) $(RUNPARAMS) -t2
+
+run4:
+	$(PROGRAM) $(RUNPARAMS) -t4
+
+run6:
+	$(PROGRAM) $(RUNPARAMS) -t6
+
+run8:
+	$(PROGRAM) $(RUNPARAMS) -t8
+
+run12:
+	$(PROGRAM) $(RUNPARAMS) -t12
+
+run16:
+	$(PROGRAM) $(RUNPARAMS) -t16
+
+run32:
+	$(PROGRAM) $(RUNPARAMS) -t32
+
+run64:
+	$(PROGRAM) $(RUNPARAMS) -t64
+
+run128:
+	$(PROGRAM) $(RUNPARAMS) -t128
+
+run-16:
+	$(PROGRAM) $(RUNPARAMS) -t-16
+
+run-32:
+	$(PROGRAM) $(RUNPARAMS) -t-32
 
+run-64:
+	$(PROGRAM) $(RUNPARAMS) -t-64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/intruder/dictionary.c stamp-0.9.10_Distribute/intruder/dictionary.c
--- stamp-0.9.10/intruder/dictionary.c	2008-09-09 07:41:52.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/dictionary.c	2014-12-18 12:19:32.582568680 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <string.h>
@@ -79,6 +80,79 @@
 
 
 char* global_defaultSignatures[] = {
+#ifdef __370__
+    "\x61\x62\x6f\x75\x74",
+    "\x61\x66\x74\x65\x72",
+    "\x61\x6c\x6c",
+    "\x61\x6c\x73\x6f",
+    "\x61\x6e\x64",
+    "\x61\x6e\x79",
+    "\x62\x61\x63\x6b",
+    "\x62\x65\x63\x61\x75\x73\x65",
+    "\x62\x75\x74",
+    "\x63\x61\x6e",
+    "\x63\x6f\x6d\x65",
+    "\x63\x6f\x75\x6c\x64",
+    "\x64\x61\x79",
+    "\x65\x76\x65\x6e",
+    "\x66\x69\x72\x73\x74",
+    "\x66\x6f\x72",
+    "\x66\x72\x6f\x6d",
+    "\x67\x65\x74",
+    "\x67\x69\x76\x65",
+    "\x67\x6f\x6f\x64",
+    "\x68\x61\x76\x65",
+    "\x68\x69\x6d",
+    "\x68\x6f\x77",
+    "\x69\x6e\x74\x6f",
+    "\x69\x74\x73",
+    "\x6a\x75\x73\x74",
+    "\x6b\x6e\x6f\x77",
+    "\x6c\x69\x6b\x65",
+    "\x6c\x6f\x6f\x6b",
+    "\x6d\x61\x6b\x65",
+    "\x6d\x6f\x73\x74",
+    "\x6e\x65\x77",
+    "\x6e\x6f\x74",
+    "\x6e\x6f\x77",
+    "\x6f\x6e\x65",
+    "\x6f\x6e\x6c\x79",
+    "\x6f\x74\x68\x65\x72",
+    "\x6f\x75\x74",
+    "\x6f\x76\x65\x72",
+    "\x70\x65\x6f\x70\x6c\x65",
+    "\x73\x61\x79",
+    "\x73\x65\x65",
+    "\x73\x68\x65",
+    "\x73\x6f\x6d\x65",
+    "\x74\x61\x6b\x65",
+    "\x74\x68\x61\x6e",
+    "\x74\x68\x61\x74",
+    "\x74\x68\x65\x69\x72",
+    "\x74\x68\x65\x6d",
+    "\x74\x68\x65\x6e",
+    "\x74\x68\x65\x72\x65",
+    "\x74\x68\x65\x73\x65",
+    "\x74\x68\x65\x79",
+    "\x74\x68\x69\x6e\x6b",
+    "\x74\x68\x69\x73",
+    "\x74\x69\x6d\x65",
+    "\x74\x77\x6f",
+    "\x75\x73\x65",
+    "\x77\x61\x6e\x74",
+    "\x77\x61\x79",
+    "\x77\x65\x6c\x6c",
+    "\x77\x68\x61\x74",
+    "\x77\x68\x65\x6e",
+    "\x77\x68\x69\x63\x68",
+    "\x77\x68\x6f",
+    "\x77\x69\x6c\x6c",
+    "\x77\x69\x74\x68",
+    "\x77\x6f\x72\x6b",
+    "\x77\x6f\x75\x6c\x64",
+    "\x79\x65\x61\x72",
+    "\x79\x6f\x75\x72"
+#else
     "about",
     "after",
     "all",
@@ -150,6 +224,7 @@
     "would",
     "year",
     "your"
+#endif
 };
 
 const long global_numDefaultSignature =
diff -Naur -x .svn stamp-0.9.10/intruder/intruder.c stamp-0.9.10_Distribute/intruder/intruder.c
--- stamp-0.9.10/intruder/intruder.c	2008-09-09 07:41:53.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/intruder.c	2014-12-18 12:19:41.091574853 +0900
@@ -67,10 +67,15 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include "decoder.h"
@@ -81,6 +86,10 @@
 #include "thread.h"
 #include "timer.h"
 #include "tm.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 enum param_types {
     PARAM_ATTACK = (unsigned char)'a',
@@ -196,7 +205,7 @@
     while (1) {
 
         char* bytes;
-        TM_BEGIN();
+        TM_BEGIN_ID(0);
         bytes = TMSTREAM_GETPACKET(streamPtr);
         TM_END();
         if (!bytes) {
@@ -207,7 +216,7 @@
         long flowId = packetPtr->flowId;
 
         error_t error;
-        TM_BEGIN();
+        TM_BEGIN_ID(1);
         error = TMDECODER_PROCESS(decoderPtr,
                                   bytes,
                                   (PACKET_HEADER_LENGTH + packetPtr->length));
@@ -223,7 +232,7 @@
 
         char* data;
         long decodedFlowId;
-        TM_BEGIN();
+        TM_BEGIN_ID(2);
         data = TMDECODER_GETCOMPLETE(decoderPtr, &decodedFlowId);
         TM_END();
         if (data) {
@@ -257,6 +266,46 @@
      */
 
     parseArgs(argc, (char** const)argv);
+#if defined(__bgq__)
+    if (global_params[PARAM_THREAD] < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -global_params[PARAM_THREAD];
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    global_params[PARAM_THREAD] = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    global_params[PARAM_THREAD] = 2;
+	    break;
+	case 2:
+	    global_params[PARAM_THREAD] = 4;
+	    break;
+	case 3:
+	    global_params[PARAM_THREAD] = 8;
+	    break;
+	case 4:
+	    global_params[PARAM_THREAD] = 16;
+	    break;
+	case 5:
+	    global_params[PARAM_THREAD] = 32;
+	    break;
+	case 6:
+	    global_params[PARAM_THREAD] = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < global_params[PARAM_THREAD]) {
+	    exit(0);
+	}
+    }
+#endif
     long numThread = global_params[PARAM_THREAD];
     SIM_GET_NUM_CPU(numThread);
     TM_STARTUP(numThread);
diff -Naur -x .svn stamp-0.9.10/intruder/Makefile.hle_intel stamp-0.9.10_Distribute/intruder/Makefile.hle_intel
--- stamp-0.9.10/intruder/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/Makefile.hle_intel	2014-12-18 12:37:46.544631936 +0900
@@ -0,0 +1,47 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+.PHONY: test_decoder
+test_decoder: CFLAGS += -DTEST_DECODER -O0
+test_decoder: LIB_SRCS := $(LIB)/{list,mt19937ar,queue,random,rbtree}.c
+test_decoder:
+	$(CC) $(CFLAGS) decoder.c packet.c $(LIB_SRCS) -o $@
+
+.PHONY: test_detector
+test_detector: CFLAGS += -DTEST_DETECTOR -O0
+test_detector: LIB_SRCS := $(LIB)/vector.c
+test_detector:
+	$(CC) $(CFLAGS) detector.c dictionary.c preprocessor.c $(LIB_SRCS) -o $@
+
+.PHONY: test_dictionary
+test_dictionary: CFLAGS += -DTEST_DICTIONARY -O0
+test_dictionary: LIB_SRCS := $(LIB)/vector.c
+test_dictionary:
+	$(CC) $(CFLAGS) dictionary.c $(LIB_SRCS) -o $@
+
+.PHONY: test_preprocessor
+test_preprocessor: CFLAGS += -DTEST_PREPROCESSOR -O0
+test_preprocessor:
+	$(CC) $(CFLAGS) preprocessor.c -o $@
+
+.PHONY: test_stream
+test_stream: CFLAGS += -DTEST_STREAM -O0
+test_stream: LIB_SRCS := $(LIB)/{mt19937ar,pair,queue,random,rbtree,vector}.c
+test_stream:
+	$(CC) $(CFLAGS) stream.c detector.c dictionary.c preprocessor.c $(LIB_SRCS) -o $@
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/intruder/Makefile.htm_ibm stamp-0.9.10_Distribute/intruder/Makefile.htm_ibm
--- stamp-0.9.10/intruder/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/Makefile.htm_ibm	2014-12-18 12:37:53.246627623 +0900
@@ -0,0 +1,47 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+.PHONY: test_decoder
+test_decoder: CFLAGS += -DTEST_DECODER -O0
+test_decoder: LIB_SRCS := $(LIB)/{list,mt19937ar,queue,random,rbtree}.c
+test_decoder:
+	$(CC) $(CFLAGS) decoder.c packet.c $(LIB_SRCS) -o $@
+
+.PHONY: test_detector
+test_detector: CFLAGS += -DTEST_DETECTOR -O0
+test_detector: LIB_SRCS := $(LIB)/vector.c
+test_detector:
+	$(CC) $(CFLAGS) detector.c dictionary.c preprocessor.c $(LIB_SRCS) -o $@
+
+.PHONY: test_dictionary
+test_dictionary: CFLAGS += -DTEST_DICTIONARY -O0
+test_dictionary: LIB_SRCS := $(LIB)/vector.c
+test_dictionary:
+	$(CC) $(CFLAGS) dictionary.c $(LIB_SRCS) -o $@
+
+.PHONY: test_preprocessor
+test_preprocessor: CFLAGS += -DTEST_PREPROCESSOR -O0
+test_preprocessor:
+	$(CC) $(CFLAGS) preprocessor.c -o $@
+
+.PHONY: test_stream
+test_stream: CFLAGS += -DTEST_STREAM -O0
+test_stream: LIB_SRCS := $(LIB)/{mt19937ar,pair,queue,random,rbtree,vector}.c
+test_stream:
+	$(CC) $(CFLAGS) stream.c detector.c dictionary.c preprocessor.c $(LIB_SRCS) -o $@
+	
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/intruder/preprocessor.c stamp-0.9.10_Distribute/intruder/preprocessor.c
--- stamp-0.9.10/intruder/preprocessor.c	2008-09-09 07:41:53.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/preprocessor.c	2014-12-18 12:19:50.424575583 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -122,7 +123,12 @@
     char* src = str;
 
     while (*src != '\0') {
+#ifdef __370__
+      if ('\x41' <= *src && *src <= '\x5a')
+	*src += 32;
+#else
         *src = (char)tolower((int)*src);
+#endif
         src++;
     }
 }
diff -Naur -x .svn stamp-0.9.10/intruder/stream.c stamp-0.9.10_Distribute/intruder/stream.c
--- stamp-0.9.10/intruder/stream.c	2008-09-09 07:41:53.000000000 +0900
+++ stamp-0.9.10_Distribute/intruder/stream.c	2014-12-18 12:19:55.581754717 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -223,7 +224,11 @@
     random_seed(randomPtr, seed);
     queue_clear(packetQueuePtr);
 
+#ifdef __370__
+    long range = '\x7e' - '\x20' + 1;
+#else
     long range = '~' - ' ' + 1;
+#endif
     assert(range > 0);
 
     long f;
@@ -246,7 +251,11 @@
             assert(status);
             long l;
             for (l = 0; l < length; l++) {
+#ifdef __370__
+                str[l] = '\x20' + (char)(random_generate(randomPtr) % range);
+#else
                 str[l] = ' ' + (char)(random_generate(randomPtr) % range);
+#endif
             }
             str[l] = '\0';
             char* str2 = (char*)malloc((length + 1) * sizeof(char));
diff -Naur -x .svn stamp-0.9.10/kmeans/Defines.common.mk stamp-0.9.10_Distribute/kmeans/Defines.common.mk
--- stamp-0.9.10/kmeans/Defines.common.mk	2008-09-09 07:41:54.000000000 +0900
+++ stamp-0.9.10_Distribute/kmeans/Defines.common.mk	2014-12-18 15:39:21.745678854 +0900
@@ -3,10 +3,19 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+hostname := $(shell hostname)
+
+CFLAGS += -DUSE_TLH
 CFLAGS += -DOUTPUT_TO_STDOUT
 
+ifeq ($(enable_IBM_optimizations),yes)
+CFLAGS += -DALIGNED_ALLOC_MEMORY
+#CFLAGS += -DLARGE_ALIGNMENT
+endif
+
 PROG := kmeans
 
 SRCS += \
@@ -17,9 +26,95 @@
 	$(LIB)/mt19937ar.c \
 	$(LIB)/random.c \
 	$(LIB)/thread.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+RUNPARAMSLOW := -m40 -n40 -t0.00001 -i inputs/random-n65536-d32-c16.txt
+RUNPARAMSHIGH := -m15 -n15 -t0.00001 -i inputs/random-n65536-d32-c16.txt
+
+.PHONY:	runlow1 runlow2 runlow4 runlow6 runlow8 runlow12 runlow16 runlow32 runlow64 runlow128 runlow-16 runlow-32 runlow-64
+
+runlow1:
+	$(PROGRAM) $(RUNPARAMSLOW) -p1
+
+runlow2:
+	$(PROGRAM) $(RUNPARAMSLOW) -p2
+
+runlow4:
+	$(PROGRAM) $(RUNPARAMSLOW) -p4
+
+runlow6:
+	$(PROGRAM) $(RUNPARAMSLOW) -p6
+
+runlow8:
+	$(PROGRAM) $(RUNPARAMSLOW) -p8
+
+runlow12:
+	$(PROGRAM) $(RUNPARAMSLOW) -p12
+
+runlow16:
+	$(PROGRAM) $(RUNPARAMSLOW) -p16
+
+runlow32:
+	$(PROGRAM) $(RUNPARAMSLOW) -p32
+
+runlow64:
+	$(PROGRAM) $(RUNPARAMSLOW) -p64
+
+runlow128:
+	$(PROGRAM) $(RUNPARAMSLOW) -p128
+
+runlow-16:
+	$(PROGRAM) $(RUNPARAMSLOW) -p-16
+
+runlow-32:
+	$(PROGRAM) $(RUNPARAMSLOW) -p-32
+
+runlow-64:
+	$(PROGRAM) $(RUNPARAMSLOW) -p-64
+
+
+.PHONY:	runhigh1 runhigh2 runhigh4 runhigh6 runhigh8 runhigh12 runhigh16 runhigh32 runhigh64 runhigh128 runhigh-16 runhigh-32 runhigh-64
+
+runhigh1:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p1
+
+runhigh2:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p2
+
+runhigh4:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p4
+
+runhigh6:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p6
+
+runhigh8:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p8
+
+runhigh12:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p12
+
+runhigh16:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p16
+
+runhigh32:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p32
+
+runhigh64:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p64
+
+runhigh128:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p128
+
+runhigh-16:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p-16
+
+runhigh-32:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p-32
+
+runhigh-64:
+	$(PROGRAM) $(RUNPARAMSHIGH) -p-64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/kmeans/kmeans.c stamp-0.9.10_Distribute/kmeans/kmeans.c
--- stamp-0.9.10/kmeans/kmeans.c	2008-09-09 07:41:54.000000000 +0900
+++ stamp-0.9.10_Distribute/kmeans/kmeans.c	2014-12-18 12:20:04.629586536 +0900
@@ -91,11 +91,16 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
 #include <fcntl.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include <math.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -108,6 +113,10 @@
 #include "thread.h"
 #include "tm.h"
 #include "util.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 #define MAX_LINE_LENGTH 1000000 /* max input is 400000 one digit input + spaces */
 
@@ -189,6 +198,46 @@
                       break;
         }
     }
+#if defined(__bgq__)
+    if (nthreads < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -nthreads;
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    nthreads = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    nthreads = 2;
+	    break;
+	case 2:
+	    nthreads = 4;
+	    break;
+	case 3:
+	    nthreads = 8;
+	    break;
+	case 4:
+	    nthreads = 16;
+	    break;
+	case 5:
+	    nthreads = 32;
+	    break;
+	case 6:
+	    nthreads = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < nthreads) {
+	    exit(0);
+	}
+    }
+#endif
 
     if (filename == 0) {
         usage((char*)argv[0]);
diff -Naur -x .svn stamp-0.9.10/kmeans/Makefile.hle_intel stamp-0.9.10_Distribute/kmeans/Makefile.hle_intel
--- stamp-0.9.10/kmeans/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/kmeans/Makefile.hle_intel	2014-12-18 12:38:32.455573471 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/kmeans/Makefile.htm_ibm stamp-0.9.10_Distribute/kmeans/Makefile.htm_ibm
--- stamp-0.9.10/kmeans/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/kmeans/Makefile.htm_ibm	2014-12-18 12:38:37.761586534 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/kmeans/normal.c stamp-0.9.10_Distribute/kmeans/normal.c
--- stamp-0.9.10/kmeans/normal.c	2008-09-09 07:41:54.000000000 +0900
+++ stamp-0.9.10_Distribute/kmeans/normal.c	2014-12-18 12:20:22.069722640 +0900
@@ -80,6 +80,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -87,6 +88,9 @@
 #include <stdlib.h>
 #include <float.h>
 #include <math.h>
+#ifdef ALIGNED_ALLOC_MEMORY
+#include <string.h>
+#endif
 #include "common.h"
 #include "normal.h"
 #include "random.h"
@@ -165,7 +169,7 @@
             membership[i] = index;
 
             /* Update new cluster centers : sum of objects located within */
-            TM_BEGIN();
+            TM_BEGIN_ID(0);
             TM_SHARED_WRITE(*new_centers_len[index],
                             TM_SHARED_READ(*new_centers_len[index]) + 1);
             for (j = 0; j < nfeatures; j++) {
@@ -179,7 +183,7 @@
 
         /* Update task queue */
         if (start + CHUNK < npoints) {
-            TM_BEGIN();
+            TM_BEGIN_ID(1);
             start = (int)TM_SHARED_READ(global_i);
             TM_SHARED_WRITE(global_i, (start + CHUNK));
             TM_END();
@@ -188,7 +192,7 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(2);
     TM_SHARED_WRITE_F(global_delta, TM_SHARED_READ_F(global_delta) + delta);
     TM_END();
 
@@ -218,6 +222,9 @@
     float** clusters;      /* out: [nclusters][nfeatures] */
     float** new_centers;   /* [nclusters][nfeatures] */
     void* alloc_memory = NULL;
+#ifdef ALIGNED_ALLOC_MEMORY
+    void *aligned_alloc_memory;
+#endif
     args_t args;
     TIMER_T start;
     TIMER_T stop;
@@ -249,15 +256,42 @@
      */
     {
         int cluster_size = sizeof(int) + sizeof(float) * nfeatures;
+#if defined(LARGE_ALIGNMENT)
+        const int cacheLineSize = 1048576;
+#elif defined( __370__)
+        const int cacheLineSize = 256;
+#elif defined(__bgq__)
+        const int cacheLineSize = 128;
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+        const int cacheLineSize = 128;
+#elif defined(__x86_64__)
+        const int cacheLineSize = 64;
+#else
         const int cacheLineSize = 32;
+#endif
         cluster_size += (cacheLineSize-1) - ((cluster_size-1) % cacheLineSize);
+#ifdef ALIGNED_ALLOC_MEMORY
+#ifdef LARGE_ALIGNMENT
+        alloc_memory = malloc(nclusters * cluster_size + cacheLineSize * 2);
+#else
+        alloc_memory = malloc(nclusters * cluster_size + cacheLineSize);
+#endif
+	aligned_alloc_memory = (void *)(((uintptr_t)alloc_memory + cacheLineSize - 1) & ~(cacheLineSize - 1));
+	memset(aligned_alloc_memory, 0, nclusters * cluster_size);
+#else
         alloc_memory = calloc(nclusters, cluster_size);
+#endif
         new_centers_len = (int**) malloc(nclusters * sizeof(int*));
         new_centers = (float**) malloc(nclusters * sizeof(float*));
         assert(alloc_memory && new_centers && new_centers_len);
         for (i = 0; i < nclusters; i++) {
+#ifdef ALIGNED_ALLOC_MEMORY
+            new_centers_len[i] = (int*)((char*)aligned_alloc_memory + cluster_size * i);
+            new_centers[i] = (float*)((char*)aligned_alloc_memory + cluster_size * i + sizeof(int));
+#else
             new_centers_len[i] = (int*)((char*)alloc_memory + cluster_size * i);
             new_centers[i] = (float*)((char*)alloc_memory + cluster_size * i + sizeof(int));
+#endif
         }
     }
 
diff -Naur -x .svn stamp-0.9.10/labyrinth/Defines.common.mk stamp-0.9.10_Distribute/labyrinth/Defines.common.mk
--- stamp-0.9.10/labyrinth/Defines.common.mk	2008-09-09 07:42:37.000000000 +0900
+++ stamp-0.9.10_Distribute/labyrinth/Defines.common.mk	2014-12-18 12:38:55.739712314 +0900
@@ -3,8 +3,11 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+hostname := $(shell hostname)
+
 LIBS += -lm
 
 PROG := labyrinth
@@ -22,11 +25,55 @@
 	$(LIB)/random.c \
 	$(LIB)/thread.c \
 	$(LIB)/vector.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+CFLAGS += -DUSE_TLH
 CFLAGS += -DUSE_EARLY_RELEASE
 
+RUNPARAMS := -i inputs/random-x512-y512-z7-n512.txt -t
+
+.PHONY:	run1 run2 run4 run6 run8 run12 run16 run32 run64 run128 run-16 run-32 run-64
+
+run1:
+	$(PROGRAM) $(RUNPARAMS) 1
+
+run2:
+	$(PROGRAM) $(RUNPARAMS) 2
+
+run4:
+	$(PROGRAM) $(RUNPARAMS) 4
+
+run6:
+	$(PROGRAM) $(RUNPARAMS) 6
+
+run8:
+	$(PROGRAM) $(RUNPARAMS) 8
+
+run12:
+	$(PROGRAM) $(RUNPARAMS) 12
+
+run16:
+	$(PROGRAM) $(RUNPARAMS) 16
+
+run32:
+	$(PROGRAM) $(RUNPARAMS) 32
+
+run64:
+	$(PROGRAM) $(RUNPARAMS) 64
+
+run128:
+	$(PROGRAM) $(RUNPARAMS) 128
+
+run-16:
+	$(PROGRAM) $(RUNPARAMS) -16
+
+run-32:
+	$(PROGRAM) $(RUNPARAMS) -32
+
+run-64:
+	$(PROGRAM) $(RUNPARAMS) -64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/labyrinth/grid.c stamp-0.9.10_Distribute/labyrinth/grid.c
--- stamp-0.9.10/labyrinth/grid.c	2008-09-09 07:42:37.000000000 +0900
+++ stamp-0.9.10_Distribute/labyrinth/grid.c	2014-12-18 12:20:38.544719822 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -80,7 +81,17 @@
 #include "vector.h"
 
 
+#if defined( __370__)
+const unsigned long CACHE_LINE_SIZE = 256UL;
+#elif defined(__bgq__)
+const unsigned long CACHE_LINE_SIZE = 128UL;
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+const unsigned long CACHE_LINE_SIZE = 128UL;
+#elif defined(__x86_64__)
+const unsigned long CACHE_LINE_SIZE = 64UL;
+#else
 const unsigned long CACHE_LINE_SIZE = 32UL;
+#endif
 
 
 /* =============================================================================
diff -Naur -x .svn stamp-0.9.10/labyrinth/labyrinth.c stamp-0.9.10_Distribute/labyrinth/labyrinth.c
--- stamp-0.9.10/labyrinth/labyrinth.c	2008-09-09 07:42:37.000000000 +0900
+++ stamp-0.9.10_Distribute/labyrinth/labyrinth.c	2014-12-18 12:20:30.266573161 +0900
@@ -67,10 +67,15 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include "list.h"
@@ -79,6 +84,10 @@
 #include "thread.h"
 #include "timer.h"
 #include "types.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 enum param_types {
     PARAM_BENDCOST = (unsigned char)'b',
@@ -195,6 +204,46 @@
      * Initialization
      */
     parseArgs(argc, (char** const)argv);
+#if defined(__bgq__)
+    if (global_params[PARAM_THREAD] < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -global_params[PARAM_THREAD];
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    global_params[PARAM_THREAD] = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    global_params[PARAM_THREAD] = 2;
+	    break;
+	case 2:
+	    global_params[PARAM_THREAD] = 4;
+	    break;
+	case 3:
+	    global_params[PARAM_THREAD] = 8;
+	    break;
+	case 4:
+	    global_params[PARAM_THREAD] = 16;
+	    break;
+	case 5:
+	    global_params[PARAM_THREAD] = 32;
+	    break;
+	case 6:
+	    global_params[PARAM_THREAD] = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < global_params[PARAM_THREAD]) {
+	    exit(0);
+	}
+    }
+#endif
     long numThread = global_params[PARAM_THREAD];
     SIM_GET_NUM_CPU(numThread);
     TM_STARTUP(numThread);
